import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { GltTicketTemplate, GltTicketTemplateParam } from './model';

/**
 * 分页查询水票
 */
export async function pageGltTicketTemplate(params: GltTicketTemplateParam) {
  const res = await request.get<ApiResult<PageResult<GltTicketTemplate>>>(
    '/glt/glt-ticket-template/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询水票列表
 */
export async function listGltTicketTemplate(params?: GltTicketTemplateParam) {
  const res = await request.get<ApiResult<GltTicketTemplate[]>>(
    '/glt/glt-ticket-template',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加水票
 */
export async function addGltTicketTemplate(data: GltTicketTemplate) {
  const res = await request.post<ApiResult<unknown>>(
    '/glt/glt-ticket-template',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改水票
 */
export async function updateGltTicketTemplate(data: GltTicketTemplate) {
  const res = await request.put<ApiResult<unknown>>(
    '/glt/glt-ticket-template',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除水票
 */
export async function removeGltTicketTemplate(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/glt/glt-ticket-template/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除水票
 */
export async function removeBatchGltTicketTemplate(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/glt/glt-ticket-template/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询水票
 */
export async function getGltTicketTemplate(id: number) {
  const res = await request.get<ApiResult<GltTicketTemplate>>(
    '/glt/glt-ticket-template/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据商品ID查询水票模板
 */
export async function getGltTicketTemplateByGoodsId(id: number) {
  const res = await request.get<ApiResult<GltTicketTemplate>>(
    '/glt/glt-ticket-template/getByGoodsId/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
